package devmanuals.com;

import java.util.concurrent.BlockingDeque;
import java.util.concurrent.LinkedBlockingDeque;

class Size implements Runnable{
	String name;
	BlockingDeque<Integer> bdq;
	public Size(String name,BlockingDeque<Integer> bdq){
		this.name= name;
		this.bdq=bdq;
	}
	public void run(){
		int i;
		boolean bol= bdq.isEmpty();
		System.out.println("Deque is empty "+bol);
		if(bol==false){
		System.out.println("Elements of deque are :"+bdq);
		try{
			Thread.sleep(500);
			int s = bdq.size();			
			System.out.println("Size of deque = "+s);
		}catch(InterruptedException e){
			e.printStackTrace();
		}
	}else{
		System.out.println(name+" inserted elements into deque are :");
		for(i=0;i<5; i++){
			bdq.add(i);
		System.out.println(i);
		try{
			Thread.sleep(1000);
		}
		catch(InterruptedException e){
			e.printStackTrace();
			}
		}
		int s = bdq.size();			
		System.out.println("Size of deque = "+s);
	}
 }
}
class Size1 implements Runnable{
	String name;
	BlockingDeque<Integer> bdq;
	
	public Size1(String name,BlockingDeque<Integer> bdq){
		this.name = name;
		this.bdq = bdq;
	}
	public void run(){
		try{
		bdq.removeAll(bdq);
		System.out.println("Elements of deque are = "+bdq);
		System.out.println("Size of deque : "+bdq.size());
		Thread.sleep(6000);
		}
		catch(InterruptedException e){
			e.printStackTrace();
		}
	}
}
public class BdqSize {
	public static void main(String args []){
	BlockingDeque<Integer> bdq = new LinkedBlockingDeque<Integer>(5);
	Runnable a =new Size("A", bdq);
	Runnable b =new Size("B", bdq);
	new Thread(a).start();
	try{
		Thread.sleep(5000);
		}
		catch(InterruptedException e){
			e.printStackTrace();
		}
	new Thread(b).start();
	}
}
